unit ABCtypeU;

// DON'T DELETE THIS COMMENT !!!

{ "AlPhAbEt" - ("ABC") - Interpreter }

{--------------------------------------------}
{ Unit:     ABCtypeU.pas                     }
{ Version:  0.14                             }
{                                            }
{ Coder:    Raiden                           }
{ Producer: ShiKai                           }
{                                            }
{ I'm NOT Liable For Damages Of ANY Kind !!! }
{--------------------------------------------}

// DON'T DELETE THIS COMMENT !!!

interface

{$I ABCcompI.inc}

const
  CDeltaSize = 025;

type
  PPointer = ^Pointer;

  TExRegNumber   = 001 .. 011;
  THiLoRegNumber = 001 .. 026;

  TExRegArray = array [Low(TExRegNumber) .. High(TExRegNumber)] of AnsiChar;
  THiRegArray = array [Low(THiLoRegNumber) .. High(THiLoRegNumber)] of AnsiChar;
  TLoRegArray = array [Low(THiLoRegNumber) .. High(THiLoRegNumber)] of AnsiChar;

  TAnsiStringArray = array of AnsiString;
  PAnsiStringArray = ^TAnsiStringArray;

  TReadValueMethod = procedure (var AValue : AnsiChar;
                                var ADone : Boolean);
  TWriteValueMethod = procedure (const AValue : AnsiChar;
                                 var ADone : Boolean);

  TBasicPointerListArray = array of Pointer;
  TBasicPointerList = class(TObject)
  private
  protected
    FArray     : TBasicPointerListArray;
    FCount     : LongWord;
    FDeltaSize : LongWord;

    function AdjustSize : Boolean; overload;
    function AdjustSize(const ADeltaSize : LongWord) : Boolean; overload;
    function DecreaseSize : Boolean; overload;
    function DecreaseSize(const ADeltaSize : LongWord) : Boolean; overload;
    function IncreaseSize : Boolean; overload;
    function IncreaseSize(const ADeltaSize : LongWord) : Boolean; overload;
    function GetItem(const AIndex : LongWord) : Pointer;

    procedure SetDeltaSize(const AValue : LongWord);
    procedure SetItem(const AIndex : LongWord;
                      const AValue : Pointer);
  public
    constructor Create;

    destructor Destroy; override;

    property Count                          : LongWord read FCount;
    property DeltaSize                      : LongWord read FDeltaSize write SetDeltaSize default CDeltaSize;
    property Items[const AIndex : LongWord] : Pointer  read GetItem    write SetItem;

    function Add(const AValue : Pointer) : LongWord;
    function Clear : Boolean;
    function Delete(const AIndex : LongWord) : Boolean;
    function DeleteFirst : Boolean;
    function DeleteLast : Boolean;
    function Insert(const AValue : Pointer;
                    const AIndex : LongWord) : Boolean;
    function InsertAsFirst(const AValue : Pointer) : Boolean;
    function InsertAsLast(const AValue : Pointer) : Boolean;
    function IsInLowerRange(const AIndex : LongWord) : Boolean;
    function IsInRange(const AIndex : LongWord) : Boolean;
    function IsInUpperRange(const AIndex : LongWord) : Boolean;
    function PutFirstToLast : Boolean;
    function PutLastToFirst : Boolean;
  published
  end;

  TPointerList = class(TBasicPointerList)
  private
  protected
    FEntriesOrder : TBasicPointerList;

    function GetEntry(const AIndex : LongWord) : Pointer;
    function GetItem(const AIndex : LongWord) : Pointer;

    procedure SetItem(const AIndex : LongWord;
                      const AValue : Pointer);
  public
    constructor Create;

    destructor Destroy; override;

    property Entries[const AIndex : LongWord] : Pointer read GetEntry;
    property Items[const AIndex : LongWord]   : Pointer read GetItem  write SetItem;

    function Add(const AValue : Pointer) : LongWord;
    function Clear : Boolean;
    function Delete(const AIndex : LongWord) : Boolean;
    function DeleteFirst : Boolean;
    function DeleteLast : Boolean;
    function Insert(const AValue : Pointer;
                    const AIndex : LongWord) : Boolean;
    function InsertAsFirst(const AValue : Pointer) : Boolean;
    function InsertAsLast(const AValue : Pointer) : Boolean;
    function IsFirstAddedEntry(const AIndex : LongWord) : Boolean;
    function IsLastAddedEntry(const AIndex : LongWord) : Boolean;
  published
  end;

  TAnsiCharList = class(TPointerList)
  private
  protected
    function GetItem(const AIndex : LongWord) : AnsiChar;

    procedure SetItem(const AIndex : LongWord;
                      const AValue : AnsiChar);
  public
    constructor Create;

    destructor Destroy; override;

    property Items[const AIndex : LongWord] : AnsiChar read GetItem write SetItem;

    function Add(const AValue : AnsiChar) : LongWord;
    function Clear : Boolean;
    function Delete(const AIndex : LongWord) : Boolean;
    function DeleteFirst : Boolean;
    function DeleteLast : Boolean;
    function Insert(const AValue : AnsiChar;
                    const AIndex : LongWord) : Boolean;
    function InsertAsFirst(const AValue : AnsiChar) : Boolean;
    function InsertAsLast(const AValue : AnsiChar) : Boolean;
  published
  end;

{$IfDef UseLocalRegisters}
  TRegistersItem = class(TObject)
  private
  protected
    FExRegArray    : TExRegArray;
    FHiRegArray    : THiRegArray;
    FLocalValidity : Boolean;
    FLoRegArray    : TLoRegArray;

    function GetExRegArray(const AIndex : TExRegNumber) : AnsiChar;
    function GetHiRegArray(const AIndex : THiLoRegNumber) : AnsiChar;
    function GetLoRegArray(const AIndex : THiLoRegNumber) : AnsiChar;

    procedure SetExRegArray(const AIndex : TExRegNumber;
                            const AValue : AnsiChar);
    procedure SetHiRegArray(const AIndex : THiLoRegNumber;
                            const AValue : AnsiChar);
    procedure SetLoRegArray(const AIndex : THiLoRegNumber;
                            const AValue : AnsiChar);
  public
    constructor Create;

    property ExRegArray[const AIndex : TExRegNumber]   : AnsiChar read GetExRegArray  write SetExRegArray;
    property HiRegArray[const AIndex : THiLoRegNumber] : AnsiChar read GetHiRegArray  write SetHiRegArray;
    property LocalValidity                             : Boolean  read FLocalValidity write FLocalValidity default false;
    property LoRegArray[const AIndex : THiLoRegNumber] : AnsiChar read GetLoRegArray  write SetLoRegArray;

    function CatchRegister(const AValue : AnsiChar) : PAnsiChar;
    function CatchExRegister(const AValue : AnsiChar) : PAnsiChar;
    function CatchHiRegister(const AValue : AnsiChar) : PAnsiChar;
    function CatchLoRegister(const AValue : AnsiChar) : PAnsiChar;

    procedure Assign(const AValue : TRegistersItem);
    procedure Initialize;
  published
  end;
{$EndIf UseLocalRegisters}

implementation

uses
  ABCsymU;

{ TBasicPointerList }

function TBasicPointerList.AdjustSize : Boolean;
begin
  Result := AdjustSize(FDeltaSize);
end;

function TBasicPointerList.AdjustSize(const ADeltaSize : LongWord) : Boolean;
begin
  Result := true;

  if (ADeltaSize > 000) then
  begin
    SetLength(FArray,
              Succ(FCount div ADeltaSize) * ADeltaSize);

    Result := (Length(FArray) = (Succ(FCount div ADeltaSize) * ADeltaSize));
  end;
end;

function TBasicPointerList.DecreaseSize : Boolean;
begin
  Result := DecreaseSize(FDeltaSize);
end;

function TBasicPointerList.DecreaseSize(const ADeltaSize : LongWord) : Boolean;
begin
  if (Length(FArray) >= ADeltaSize) then
    SetLength(FArray,
              Length(FArray) - ADeltaSize);

  Result := (Length(FArray) = (Length(FArray) - ADeltaSize));
end;

function TBasicPointerList.GetItem(const AIndex : LongWord) : Pointer;
begin
  Result := nil;

  if IsInRange(AIndex) then
    Result := FArray[AIndex];
end;

function TBasicPointerList.IncreaseSize : Boolean;
begin
  Result := IncreaseSize(FDeltaSize);
end;

function TBasicPointerList.IncreaseSize(const ADeltaSize : LongWord) : Boolean;
begin
  SetLength(FArray,
            Length(FArray) + ADeltaSize);

  Result := (Length(FArray) = (Length(FArray) + ADeltaSize));
end;

procedure TBasicPointerList.SetDeltaSize(const AValue : LongWord);
begin
  if ((AValue <> FDeltaSize) and
      (AValue > 000)) then
    FDeltaSize := AValue;
end;

procedure TBasicPointerList.SetItem(const AIndex : LongWord;
                                    const AValue : Pointer);
begin
  if IsInRange(AIndex) then
    FArray[AIndex] := AValue;
end;

constructor TBasicPointerList.Create;
begin
  inherited Create;

  FDeltaSize := CDeltaSize;

  Clear;
end;

destructor TBasicPointerList.Destroy;
begin
  Clear;

  inherited Destroy;
end;

function TBasicPointerList.Add(const AValue : Pointer) : LongWord;
begin
  Result := High(LongWord);

  if AdjustSize then
  begin
    Inc(FCount);

    Items[Pred(FCount)] := AValue;

    Result := Pred(FCount);
  end;
end;

function TBasicPointerList.Clear : Boolean;
begin
  FCount := 000;

  Result := AdjustSize;
end;

function TBasicPointerList.Delete(const AIndex : LongWord) : Boolean;
var
  Index : LongWord;
begin
  Result := false;

  if IsInLowerRange(AIndex) then
  begin
    if (AIndex = Pred(FCount)) then
    begin
      Dec(FCount);

      Result := AdjustSize;
    end
    else
    begin
      if IsInUpperRange(AIndex) then
      begin
        for Index := AIndex to Pred(Pred(FCount)) do
          FArray[Index] := FArray[Succ(Index)];

        Dec(FCount);

        Result := AdjustSize;
      end;
    end;
  end;
end;

function TBasicPointerList.DeleteFirst : Boolean;
begin
  Result := Delete(000);
end;

function TBasicPointerList.DeleteLast : Boolean;
begin
  Result := Delete(Pred(FCount));
end;

function TBasicPointerList.Insert(const AValue : Pointer;
                                  const AIndex : LongWord) : Boolean;
var
  Index : LongWord;
begin
  Result := false;

  if (AIndex >= FCount) then
    Result := (Items[Add(AValue)] = AValue)
  else
  begin
    if IsInUpperRange(AIndex) then
    begin
      Add(nil);

      for Index := Pred(FCount) downto Succ(AIndex) do
        Items[Index] := Items[Pred(Index)];
      Items[AIndex] := AValue;

      Result := (Items[AIndex] = AValue);
    end;
  end;
end;

function TBasicPointerList.InsertAsFirst(const AValue : Pointer) : Boolean;
begin
  Result := Insert(AValue,
                   000);
end;

function TBasicPointerList.InsertAsLast(const AValue : Pointer) : Boolean;
begin
  Result := Insert(AValue,
                   FCount);
end;

function TBasicPointerList.IsInLowerRange(const AIndex : LongWord) : Boolean;
begin
  Result := (AIndex >= 000);
end;

function TBasicPointerList.IsInRange(const AIndex : LongWord) : Boolean;
begin
  Result := (IsInLowerRange(AIndex) and
             IsInUpperRange(AIndex));
end;

function TBasicPointerList.IsInUpperRange(const AIndex : LongWord) : Boolean;
begin
  Result := (AIndex < FCount);
end;

function TBasicPointerList.PutFirstToLast : Boolean;
begin
  Result := true;

  if (FCount > 001) then
    Result := (InsertAsLast(Items[000]) and
               DeleteFirst);
end;

function TBasicPointerList.PutLastToFirst : Boolean;
begin
  Result := true;

  if (FCount > 001) then
    Result := (InsertAsFirst(Items[Pred(Count)]) and
               DeleteLast);
end;

{ TPointerList }

function TPointerList.GetEntry(const AIndex : LongWord) : Pointer;
begin
  Result := PPointer(FEntriesOrder.Items[AIndex])^;
end;

function TPointerList.GetItem(const AIndex : LongWord) : Pointer;
begin
  Result := PPointer(inherited Items[AIndex])^;
end;

procedure TPointerList.SetItem(const AIndex : LongWord;
                               const AValue : Pointer);
begin
  PPointer(inherited Items[AIndex])^ := AValue;
end;

constructor TPointerList.Create;
begin
  inherited Create;

  FEntriesOrder := TBasicPointerList.Create;

  Clear;
end;

destructor TPointerList.Destroy;
begin
  Clear;

  FEntriesOrder.Free;
  FEntriesOrder := nil;

  inherited Destroy;
end;

function TPointerList.Add(const AValue : Pointer) : LongWord;
var
  TempPointer : PPointer;
begin
  Result := High(LongWord);

  New(TempPointer);
  try
    TempPointer^ := AValue;

    if (FEntriesOrder <> nil) then
      FEntriesOrder.Add(TempPointer);

    Result := inherited Add(TempPointer);
  except
    Dispose(TempPointer);
    TempPointer := nil;
  end;
end;

function TPointerList.Clear : Boolean;
var
  Index : LongWord;
begin
  if (Count > 000) then
  begin
    for Index := 000 to Pred(Count) do
    begin
      if (inherited Items[Index] <> nil) then
      begin
        Dispose(PPointer(inherited Items[Index]));
        inherited Items[Index] := nil;
      end;
    end;
  end;

  FEntriesOrder.Clear;

  Result := inherited Clear;
end;

function TPointerList.Delete(const AIndex : LongWord) : Boolean;
var
  Index : LongWord;
begin
  Result := false;

  if IsInRange(AIndex) then
  begin
    if (FEntriesOrder.Count > 000) then
    begin
      for Index := 000 to Pred(FEntriesOrder.Count) do
      begin
        if (inherited Items[AIndex] = FEntriesOrder.Items[Index]) then
        begin
          FEntriesOrder.Delete(Index);

          Break;
        end;
      end;
    end;

    if (inherited Items[AIndex] <> nil) then
    begin
      Dispose(PPointer(inherited Items[AIndex]));
      inherited Items[AIndex] := nil;
    end;

    Result := inherited Delete(AIndex);
  end;
end;

function TPointerList.DeleteFirst : Boolean;
begin
  Result := Delete(000);
end;

function TPointerList.DeleteLast : Boolean;
begin
  Result := Delete(Pred(Count));
end;

function TPointerList.Insert(const AValue : Pointer;
                             const AIndex : LongWord) : Boolean;
var
  TempPointer : PPointer;
begin
  Result := false;

  New(TempPointer);
  try
    TempPointer^ := AValue;

    Result := inherited Insert(TempPointer,
                               AIndex);

    if not(Result) then
    begin
      Dispose(TempPointer);
      TempPointer := nil;
    end
    else
      FEntriesOrder.Add(TempPointer);
  except
    Dispose(TempPointer);
    TempPointer := nil;
  end;
end;

function TPointerList.InsertAsFirst(const AValue : Pointer) : Boolean;
begin
  Result := Insert(AValue,
                   000);
end;

function TPointerList.InsertAsLast(const AValue : Pointer) : Boolean;
begin
  Result := Insert(AValue,
                   Count);
end;

function TPointerList.IsFirstAddedEntry(const AIndex : LongWord) : Boolean;
begin
  Result := false;

  if IsInRange(AIndex) then
    Result := (inherited Items[AIndex] = FEntriesOrder.Items[000]);
end;

function TPointerList.IsLastAddedEntry(const AIndex : LongWord) : Boolean;
begin
  Result := false;

  if IsInRange(AIndex) then
    Result := (inherited Items[AIndex] = FEntriesOrder.Items[Pred(FEntriesOrder.Count)]);
end;

{ TAnsiCharList }

function TAnsiCharList.GetItem(const AIndex : LongWord) : AnsiChar;
begin
  Result := PAnsiChar(inherited Items[AIndex])^;
end;

procedure TAnsiCharList.SetItem(const AIndex : LongWord;
                                const AValue : AnsiChar);
begin
  PAnsiChar(inherited Items[AIndex])^ := AValue;
end;

constructor TAnsiCharList.Create;
begin
  inherited Create;
end;

destructor TAnsiCharList.Destroy;
begin
  Clear;

  inherited Destroy;
end;

function TAnsiCharList.Add(const AValue : AnsiChar) : LongWord;
var
  TempChar : PAnsiChar;
begin
  Result := High(LongWord);

  New(TempChar);
  try
    TempChar^ := AValue;

    Result := inherited Add(TempChar);
  except
    Dispose(TempChar);
    TempChar := nil;
  end;
end;

function TAnsiCharList.Clear : Boolean;
var
  Index : LongWord;
begin
  if (FCount > 000) then
  begin
    for Index := 000 to Pred(FCount) do
    begin
      if (inherited Items[Index] <> nil) then
      begin
        Dispose(PAnsiChar(inherited Items[Index]));
        inherited Items[Index] := nil;
      end;
    end;
  end;

  Result := inherited Clear;
end;

function TAnsiCharList.Delete(const AIndex : LongWord) : Boolean;
begin
  Result := false;

  if IsInRange(AIndex) then
  begin
    if (inherited Items[AIndex] <> nil) then
    begin
      Dispose(PAnsiChar(inherited Items[AIndex]));
      inherited Items[AIndex] := nil;
    end;

    Result := inherited Delete(AIndex);
  end;
end;

function TAnsiCharList.DeleteFirst : Boolean;
begin
  Result := Delete(000);
end;

function TAnsiCharList.DeleteLast : Boolean;
begin
  Result := Delete(Pred(Count));
end;

function TAnsiCharList.Insert(const AValue : AnsiChar;
                              const AIndex : LongWord) : Boolean;
var
  TempChar : PAnsiChar;
begin
  Result := false;

  New(TempChar);
  try
    TempChar^ := AValue;

    Result := inherited Insert(TempChar,
                               AIndex);

    if not(Result) then
    begin
      Dispose(TempChar);
      TempChar := nil;
    end;
  except
    Dispose(TempChar);
    TempChar := nil;
  end;
end;

function TAnsiCharList.InsertAsFirst(const AValue : AnsiChar) : Boolean;
begin
  Result := Insert(AValue,
                   000);
end;

function TAnsiCharList.InsertAsLast(const AValue : AnsiChar) : Boolean;
begin
  Result := Insert(AValue,
                   FCount);
end;

{$IfDef UseLocalRegisters}
{ TRegistersItem }

function TRegistersItem.GetExRegArray(const AIndex : TExRegNumber) : AnsiChar;
begin
  Result := FExRegArray[AIndex];
end;

function TRegistersItem.GetHiRegArray(const AIndex : THiLoRegNumber) : AnsiChar;
begin
  Result := FHiRegArray[AIndex];
end;

function TRegistersItem.GetLoRegArray(const AIndex : THiLoRegNumber) : AnsiChar;
begin
  Result := FLoRegArray[AIndex];
end;

procedure TRegistersItem.SetExRegArray(const AIndex : TExRegNumber;
                                       const AValue : AnsiChar);
begin
  FExRegArray[AIndex] := AValue;
end;

procedure TRegistersItem.SetHiRegArray(const AIndex : THiLoRegNumber;
                                       const AValue : AnsiChar);
begin
  FHiRegArray[AIndex] := AValue;
end;

procedure TRegistersItem.SetLoRegArray(const AIndex : THiLoRegNumber;
                                       const AValue : AnsiChar);
begin
  FLoRegArray[AIndex] := AValue;
end;

constructor TRegistersItem.Create;
begin
  inherited Create;

  Initialize;
end;

function TRegistersItem.CatchRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  Result := nil;

  if IsExRegister(AValue) then
    Result := CatchExRegister(AValue);
  if IsHiRegister(AValue) then
    Result := CatchHiRegister(AValue);
  if IsLoRegister(AValue) then
    Result := CatchLoRegister(AValue);
end;

function TRegistersItem.CatchExRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CEx0Reg    : Result := @FExRegArray[001];
    CEx1Reg    : Result := @FExRegArray[002];
    CEx2Reg    : Result := @FExRegArray[003];
    CEx3Reg    : Result := @FExRegArray[004];
    CEx4Reg    : Result := @FExRegArray[005];
    CEx5Reg    : Result := @FExRegArray[006];
    CEx6Reg    : Result := @FExRegArray[007];
    CEx7Reg    : Result := @FExRegArray[008];
    CEx8Reg    : Result := @FExRegArray[009];
    CEx9Reg    : Result := @FExRegArray[010];
    CExFlagReg : Result := @FExRegArray[011];
  else
    Result := nil;
  end;
end;

function TRegistersItem.CatchHiRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CHiAReg : Result := @FHiRegArray[001];
    CHiBReg : Result := @FHiRegArray[002];
    CHiCReg : Result := @FHiRegArray[003];
    CHiDReg : Result := @FHiRegArray[004];
    CHiEReg : Result := @FHiRegArray[005];
    CHiFReg : Result := @FHiRegArray[006];
    CHiGReg : Result := @FHiRegArray[007];
    CHiHReg : Result := @FHiRegArray[008];
    CHiIReg : Result := @FHiRegArray[009];
    CHiJReg : Result := @FHiRegArray[010];
    CHiKReg : Result := @FHiRegArray[011];
    CHiLReg : Result := @FHiRegArray[012];
    CHiMReg : Result := @FHiRegArray[013];
    CHiNReg : Result := @FHiRegArray[014];
    CHiOReg : Result := @FHiRegArray[015];
    CHiPReg : Result := @FHiRegArray[016];
    CHiQReg : Result := @FHiRegArray[017];
    CHiRReg : Result := @FHiRegArray[018];
    CHiSReg : Result := @FHiRegArray[019];
    CHiTReg : Result := @FHiRegArray[020];
    CHiUReg : Result := @FHiRegArray[021];
    CHiVReg : Result := @FHiRegArray[022];
    CHiWReg : Result := @FHiRegArray[023];
    CHiXReg : Result := @FHiRegArray[024];
    CHiYReg : Result := @FHiRegArray[025];
    CHiZReg : Result := @FHiRegArray[026];
  else
    Result := nil;
  end;
end;

function TRegistersItem.CatchLoRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CLoAReg : Result := @FLoRegArray[001];
    CLoBReg : Result := @FLoRegArray[002];
    CLoCReg : Result := @FLoRegArray[003];
    CLoDReg : Result := @FLoRegArray[004];
    CLoEReg : Result := @FLoRegArray[005];
    CLoFReg : Result := @FLoRegArray[006];
    CLoGReg : Result := @FLoRegArray[007];
    CLoHReg : Result := @FLoRegArray[008];
    CLoIReg : Result := @FLoRegArray[009];
    CLoJReg : Result := @FLoRegArray[010];
    CLoKReg : Result := @FLoRegArray[011];
    CLoLReg : Result := @FLoRegArray[012];
    CLoMReg : Result := @FLoRegArray[013];
    CLoNReg : Result := @FLoRegArray[014];
    CLoOReg : Result := @FLoRegArray[015];
    CLoPReg : Result := @FLoRegArray[016];
    CLoQReg : Result := @FLoRegArray[017];
    CLoRReg : Result := @FLoRegArray[018];
    CLoSReg : Result := @FLoRegArray[019];
    CLoTReg : Result := @FLoRegArray[020];
    CLoUReg : Result := @FLoRegArray[021];
    CLoVReg : Result := @FLoRegArray[022];
    CLoWReg : Result := @FLoRegArray[023];
    CLoXReg : Result := @FLoRegArray[024];
    CLoYReg : Result := @FLoRegArray[025];
    CLoZReg : Result := @FLoRegArray[026];
  else
    Result := nil;
  end;
end;

procedure TRegistersItem.Assign(const AValue : TRegistersItem);
var
  Index : Byte;
begin
  Initialize;

  if (AValue <> nil) then
  begin
    for Index := Low(FExRegArray) to High(FExRegArray) do
      FExRegArray[Index] := AValue.ExRegArray[Index];
    for Index := Low(FHiRegArray) to High(FHiRegArray) do
      FHiRegArray[Index] := AValue.HiRegArray[Index];
    for Index := Low(FLoRegArray) to High(FLoRegArray) do
      FLoRegArray[Index] := AValue.LoRegArray[Index];

    FLocalValidity := AValue.LocalValidity;
  end;
end;

procedure TRegistersItem.Initialize;
var
  Index : Byte;
begin
  for Index := Low(FExRegArray) to High(FExRegArray) do
    FExRegArray[Index] := C0Val;
  for Index := Low(FHiRegArray) to High(FHiRegArray) do
    FHiRegArray[Index] := C0Val;
  for Index := Low(FLoRegArray) to High(FLoRegArray) do
    FLoRegArray[Index] := C0Val;

  FLocalValidity := false;
end;
{$EndIf UseLocalRegisters}

end.
