unit ABCvarU;

// DON'T DELETE THIS COMMENT !!!

{ "AlPhAbEt" - ("ABC") - Interpreter }

{--------------------------------------------}
{ Unit:     ABCvarU.pas                      }
{ Version:  0.14                             }
{                                            }
{ Coder:    Raiden                           }
{ Producer: ShiKai                           }
{                                            }
{ I'm NOT Liable For Damages Of ANY Kind !!! }
{--------------------------------------------}

// DON'T DELETE THIS COMMENT !!!

interface

uses
  ABCtypeU;

{$I ABCcompI.inc}

var
  VReadFileValue    : TReadValueMethod;
  VReadScreenValue  : TReadValueMethod;
  VWriteFileValue   : TWriteValueMethod;
  VWriteScreenValue : TWriteValueMethod;

  VBlockExArray : array [001 .. 011] of TAnsiStringArray;
  VBlockHiArray : array [001 .. 026] of TAnsiStringArray;
  VBlockLoArray : array [001 .. 026] of TAnsiStringArray;

  VExRegArray : TExRegArray;
  VHiRegArray : THiRegArray;
  VLoRegArray : TLoRegArray;

  VInstanceCounter : LongWord;

{$IfDef UseLocalRegisters}
  VLocalRegisters : TBasicPointerList;
{$EndIf UseLocalRegisters}

  VWaitForBlockArray : AnsiChar;
  VWaitForBlockEnd   : Boolean;

  VCommandBlockArray     : TAnsiStringArray;
  VCommandBlockExecution : AnsiString;

  VMemoryList : TAnsiCharList;

{$IfDef UseStackOverflowProtection}
  VInterpreterSize : LongWord;
  VTestAfter       : LongWord;
  VTestBefore      : LongWord;
  VTestStack       : Boolean;
{$EndIf UseStackOverflowProtection}

function CatchBlockArray(const AValue : AnsiChar) : PAnsiStringArray;
function CatchBlockExArray(const AValue : AnsiChar) : PAnsiStringArray;
function CatchBlockHiArray(const AValue : AnsiChar) : PAnsiStringArray;
function CatchBlockLoArray(const AValue : AnsiChar) : PAnsiStringArray;

function CatchRegister(const AValue : AnsiChar) : PAnsiChar;
function CatchExRegister(const AValue : AnsiChar) : PAnsiChar;
function CatchHiRegister(const AValue : AnsiChar) : PAnsiChar;
function CatchLoRegister(const AValue : AnsiChar) : PAnsiChar;

function ParametersToAnsiChar : AnsiChar;
procedure AnsiCharToParameters(const AValue : AnsiChar);

procedure DeInitializeMemoryList;

{$IfDef UseLocalRegisters}
procedure DeInitializeRegisters;
{$EndIf UseLocalRegisters}

procedure InitializeBlockArrays;
procedure InitializeMemoryList;
procedure InitializeRegisters;

implementation

uses
  ABCsysU,
  ABCsymU;

function CatchBlockArray(const AValue : AnsiChar) : PAnsiStringArray;
begin
  Result := nil;

  if IsExRegister(AValue) then
    Result := CatchBlockExArray(AValue);
  if IsHiRegister(AValue) then
    Result := CatchBlockHiArray(AValue);
  if IsLoRegister(AValue) then
    Result := CatchBLockLoArray(AValue);
end;

function CatchBlockExArray(const AValue : AnsiChar) : PAnsiStringArray;
begin
  case AValue of
    CEx0Reg    : Result := @VBlockExArray[001];
    CEx1Reg    : Result := @VBlockExArray[002];
    CEx2Reg    : Result := @VBlockExArray[003];
    CEx3Reg    : Result := @VBlockExArray[004];
    CEx4Reg    : Result := @VBlockExArray[005];
    CEx5Reg    : Result := @VBlockExArray[006];
    CEx6Reg    : Result := @VBlockExArray[007];
    CEx7Reg    : Result := @VBlockExArray[008];
    CEx8Reg    : Result := @VBlockExArray[009];
    CEx9Reg    : Result := @VBlockExArray[010];
    CExFlagReg : Result := @VBlockExArray[011];
  else
    Result := nil;
  end;
end;

function CatchBlockHiArray(const AValue : AnsiChar) : PAnsiStringArray;
begin
  case AValue of
    CHiAReg : Result := @VBlockHiArray[001];
    CHiBReg : Result := @VBlockHiArray[002];
    CHiCReg : Result := @VBlockHiArray[003];
    CHiDReg : Result := @VBlockHiArray[004];
    CHiEReg : Result := @VBlockHiArray[005];
    CHiFReg : Result := @VBlockHiArray[006];
    CHiGReg : Result := @VBlockHiArray[007];
    CHiHReg : Result := @VBlockHiArray[008];
    CHiIReg : Result := @VBlockHiArray[009];
    CHiJReg : Result := @VBlockHiArray[010];
    CHiKReg : Result := @VBlockHiArray[011];
    CHiLReg : Result := @VBlockHiArray[012];
    CHiMReg : Result := @VBlockHiArray[013];
    CHiNReg : Result := @VBlockHiArray[014];
    CHiOReg : Result := @VBlockHiArray[015];
    CHiPReg : Result := @VBlockHiArray[016];
    CHiQReg : Result := @VBlockHiArray[017];
    CHiRReg : Result := @VBlockHiArray[018];
    CHiSReg : Result := @VBlockHiArray[019];
    CHiTReg : Result := @VBlockHiArray[020];
    CHiUReg : Result := @VBlockHiArray[021];
    CHiVReg : Result := @VBlockHiArray[022];
    CHiWReg : Result := @VBlockHiArray[023];
    CHiXReg : Result := @VBlockHiArray[024];
    CHiYReg : Result := @VBlockHiArray[025];
    CHiZReg : Result := @VBlockHiArray[026];
  else
    Result := nil;
  end;
end;

function CatchBlockLoArray(const AValue : AnsiChar) : PAnsiStringArray;
begin
  case AValue of
    CLoAReg : Result := @VBlockLoArray[001];
    CLoBReg : Result := @VBlockLoArray[002];
    CLoCReg : Result := @VBlockLoArray[003];
    CLoDReg : Result := @VBlockLoArray[004];
    CLoEReg : Result := @VBlockLoArray[005];
    CLoFReg : Result := @VBlockLoArray[006];
    CLoGReg : Result := @VBlockLoArray[007];
    CLoHReg : Result := @VBlockLoArray[008];
    CLoIReg : Result := @VBlockLoArray[009];
    CLoJReg : Result := @VBlockLoArray[010];
    CLoKReg : Result := @VBlockLoArray[011];
    CLoLReg : Result := @VBlockLoArray[012];
    CLoMReg : Result := @VBlockLoArray[013];
    CLoNReg : Result := @VBlockLoArray[014];
    CLoOReg : Result := @VBlockLoArray[015];
    CLoPReg : Result := @VBlockLoArray[016];
    CLoQReg : Result := @VBlockLoArray[017];
    CLoRReg : Result := @VBlockLoArray[018];
    CLoSReg : Result := @VBlockLoArray[019];
    CLoTReg : Result := @VBlockLoArray[020];
    CLoUReg : Result := @VBlockLoArray[021];
    CLoVReg : Result := @VBlockLoArray[022];
    CLoWReg : Result := @VBlockLoArray[023];
    CLoXReg : Result := @VBlockLoArray[024];
    CLoYReg : Result := @VBlockLoArray[025];
    CLoZReg : Result := @VBlockLoArray[026];
  else
    Result := nil;
  end;
end;

function CatchRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  Result := nil;

  if IsExRegister(AValue) then
    Result := CatchExRegister(AValue);
  if IsHiRegister(AValue) then
    Result := CatchHiRegister(AValue);
  if IsLoRegister(AValue) then
    Result := CatchLoRegister(AValue);
end;

function CatchExRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CEx0Reg    : Result := @VExRegArray[001];
    CEx1Reg    : Result := @VExRegArray[002];
    CEx2Reg    : Result := @VExRegArray[003];
    CEx3Reg    : Result := @VExRegArray[004];
    CEx4Reg    : Result := @VExRegArray[005];
    CEx5Reg    : Result := @VExRegArray[006];
    CEx6Reg    : Result := @VExRegArray[007];
    CEx7Reg    : Result := @VExRegArray[008];
    CEx8Reg    : Result := @VExRegArray[009];
    CEx9Reg    : Result := @VExRegArray[010];
    CExFlagReg : Result := @VExRegArray[011];
  else
    Result := nil;
  end;
end;

function CatchHiRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CHiAReg : Result := @VHiRegArray[001];
    CHiBReg : Result := @VHiRegArray[002];
    CHiCReg : Result := @VHiRegArray[003];
    CHiDReg : Result := @VHiRegArray[004];
    CHiEReg : Result := @VHiRegArray[005];
    CHiFReg : Result := @VHiRegArray[006];
    CHiGReg : Result := @VHiRegArray[007];
    CHiHReg : Result := @VHiRegArray[008];
    CHiIReg : Result := @VHiRegArray[009];
    CHiJReg : Result := @VHiRegArray[010];
    CHiKReg : Result := @VHiRegArray[011];
    CHiLReg : Result := @VHiRegArray[012];
    CHiMReg : Result := @VHiRegArray[013];
    CHiNReg : Result := @VHiRegArray[014];
    CHiOReg : Result := @VHiRegArray[015];
    CHiPReg : Result := @VHiRegArray[016];
    CHiQReg : Result := @VHiRegArray[017];
    CHiRReg : Result := @VHiRegArray[018];
    CHiSReg : Result := @VHiRegArray[019];
    CHiTReg : Result := @VHiRegArray[020];
    CHiUReg : Result := @VHiRegArray[021];
    CHiVReg : Result := @VHiRegArray[022];
    CHiWReg : Result := @VHiRegArray[023];
    CHiXReg : Result := @VHiRegArray[024];
    CHiYReg : Result := @VHiRegArray[025];
    CHiZReg : Result := @VHiRegArray[026];
  else
    Result := nil;
  end;
end;

function CatchLoRegister(const AValue : AnsiChar) : PAnsiChar;
begin
  case AValue of
    CLoAReg : Result := @VLoRegArray[001];
    CLoBReg : Result := @VLoRegArray[002];
    CLoCReg : Result := @VLoRegArray[003];
    CLoDReg : Result := @VLoRegArray[004];
    CLoEReg : Result := @VLoRegArray[005];
    CLoFReg : Result := @VLoRegArray[006];
    CLoGReg : Result := @VLoRegArray[007];
    CLoHReg : Result := @VLoRegArray[008];
    CLoIReg : Result := @VLoRegArray[009];
    CLoJReg : Result := @VLoRegArray[010];
    CLoKReg : Result := @VLoRegArray[011];
    CLoLReg : Result := @VLoRegArray[012];
    CLoMReg : Result := @VLoRegArray[013];
    CLoNReg : Result := @VLoRegArray[014];
    CLoOReg : Result := @VLoRegArray[015];
    CLoPReg : Result := @VLoRegArray[016];
    CLoQReg : Result := @VLoRegArray[017];
    CLoRReg : Result := @VLoRegArray[018];
    CLoSReg : Result := @VLoRegArray[019];
    CLoTReg : Result := @VLoRegArray[020];
    CLoUReg : Result := @VLoRegArray[021];
    CLoVReg : Result := @VLoRegArray[022];
    CLoWReg : Result := @VLoRegArray[023];
    CLoXReg : Result := @VLoRegArray[024];
    CLoYReg : Result := @VLoRegArray[025];
    CLoZReg : Result := @VLoRegArray[026];
  else
    Result := nil;
  end;
end;

function ParametersToAnsiChar : AnsiChar;
  function ExtendedPower(const ABase : Extended;
                         const AExponent : Extended) : Extended;
    function IntPower(const ABase : Extended;
                      const AExponent : LongInt) : Extended;
    asm
      MOV    ECX, EAX
      CDQ
      FLD1                                                                        { Result := 1 }
      XOR    EAX, EDX
      SUB    EAX, EDX                                                             { EAX := Abs(AExponent) }
      JZ     @@3
      FLD    ABase
      JMP    @@2
    @@1:
      FMUL   ST, ST                                                               { X := ABase * ABase }
    @@2:
      SHR    EAX, 001
      JNC    @@1
      FMUL   ST(1), ST                                                            { Result := Result * X }
      JNZ    @@1
      FSTP   ST                                                                   { pop X from FPU stack }
      CMP    ECX, 000
      JGE    @@3
      FLD1
      FDIVRP                                                                      { Result := 1 / Result }
    @@3:
      FWAIT
    end;

  begin
    if (AExponent = 0.0) then
      Result := 1.0                                                               { n^0 = 1 }
    else
    begin
      if (ABase = 0.0) and (AExponent > 0.0) then
        Result := 0.0                                                             { 0^n = 0, n > 0 }
      else
      begin
        if (Frac(AExponent) = 0.0) and (Abs(AExponent) <= MaxInt) then
          Result := IntPower(ABase,
                             LongInt(Trunc(AExponent)))
        else
          Result := Exp(AExponent * Ln(ABase));
      end;
    end;
  end;

var
  ByteResult : Byte;
  Index      : Byte;
begin
  ByteResult := 000;
  for Index := 001 to 008 do
  begin
    if IsValue(ABCValue(CExRegArray[Succ(Index)])) then
    begin
      if (ABCValue(CExRegArray[Succ(Index)]) = C1Val) then
        ByteResult := ByteResult + Trunc(ExtendedPower(002,
                                                       (008 - Index)));
    end;
  end;

  Result := AnsiChar(ByteResult);
end;

procedure AnsiCharToParameters(const AValue : AnsiChar);
  function GetDualLength(const AValue : Byte) : Byte;
  var
    TempNumber : LongInt;
  begin
    Result := 000;

    TempNumber := AValue;
    while (TempNumber <> 000) do
    begin
      TempNumber := (TempNumber div 002);

      Inc(Result);
    end;

    if (Result = 000) then
      Inc(Result);
  end;
  
var
  ByteValue  : Byte;
  Index      : Byte;
  NextNumber : Byte;
begin
  for Index := 002 to 009 do
    ABCGetRegister(CExRegArray[Index])^ := C0Val;

  ByteValue := Ord(AValue);
  if (ByteValue <> 000) then
  begin
    Index := 009;
    while (not(ByteValue = 000) and not(Index < 002)) do
    begin
      NextNumber := (ByteValue mod 002);
      ByteValue  := (ByteValue div 002);

      if (NextNumber = 001) then
        ABCGetRegister(CExRegArray[Index])^ := C1Val
      else
        ABCGetRegister(CExRegArray[Index])^ := C0Val;

      Dec(Index);
    end;
  end;
end;

procedure DeInitializeMemoryList;
begin
  if (VMemoryList <> nil) then
  begin
    VMemoryList.Free;
    VMemoryList := nil;
  end;
end;

{$IfDef UseLocalRegisters}
procedure DeInitializeRegisters;
var
  Index : Byte;
begin
  for Index := Low(VExRegArray) to High(VExRegArray) do
    VExRegArray[Index] := C0Val;
  for Index := Low(VHiRegArray) to High(VHiRegArray) do
    VHiRegArray[Index] := C0Val;
  for Index := Low(VLoRegArray) to High(VLoRegArray) do
    VLoRegArray[Index] := C0Val;

  if (VLocalRegisters <> nil) then
  begin
    VLocalRegisters.Free;
    VLocalRegisters := nil;
  end;
end;
{$EndIf UseLocalRegisters}

procedure InitializeBlockArrays;
var
  Index : Byte;
begin
  for Index := Low(VBlockExArray) to High(VBlockExArray) do
    SetLength(VBlockExArray[Index],
              000);
  for Index := Low(VBlockHiArray) to High(VBlockHiArray) do
    SetLength(VBlockHiArray[Index],
              000);
  for Index := Low(VBlockLoArray) to High(VBlockLoArray) do
    SetLength(VBlockLoArray[Index],
              000);

  VCommandBlockExecution := '';

  VWaitForBlockArray := CEmpty;
  VWaitForBlockEnd   := false;
end;

procedure InitializeMemoryList;
begin
  VMemoryList := TAnsiCharList.Create;
  try
    VMemoryList.Clear;
  except
    DeInitializeMemoryList;
  end;
end;

procedure InitializeRegisters;
var
  Index : Byte;
begin
  for Index := Low(VExRegArray) to High(VExRegArray) do
    VExRegArray[Index] := C0Val;
  for Index := Low(VHiRegArray) to High(VHiRegArray) do
    VHiRegArray[Index] := C0Val;
  for Index := Low(VLoRegArray) to High(VLoRegArray) do
    VLoRegArray[Index] := C0Val;

{$IfDef UseLocalRegisters}
  VLocalRegisters := TBasicPointerList.Create;
  try
    VLocalRegisters.Clear;
    VLocalRegisters.Add(TRegistersItem.Create);
  except
    VLocalRegisters.Free;
    VLocalRegisters := nil;
  end;
{$EndIf UseLocalRegisters}
end;

end.
